#-------------------------------------------------------------------#
# PopMeter.pl							    #
#-------------------------------------------------------------------#
# PopMeter 4 YaBB 2.1						    #
# Version 0.1 beta						    #
# by Carsten Dalgaard						    #
#-------------------------------------------------------------------#
# Copyright: 2006 'Carsten Dalgaard' - All Rights Reserved	    #
# Released: November 28, 2006					    #
# e-mail: carsten.dalgaard@gmail.com				    #
#-------------------------------------------------------------------#
# Any redistribution of this script without the expressed written   #
# consent of 'Carsten Dalgaard' is strictly prohibited. Copying     #
# any	of the code contained within this script and claiming it as #
# your own is also prohibited.					    #
#-------------------------------------------------------------------#
# By using this script you agree to indemnify 'Carsten Dalgaard'    #
# from any liability that might arise from its use.		    #
#-------------------------------------------------------------------#
# You may not remove any of these header notices.		    #
#-------------------------------------------------------------------#

#------------------------ PopMeter settings ------------------------#

$barwidth = 100;		# Set the bar width
$pop_timeout = 60;		# Set the number of minutes between two 'opinions' from the same IP
$view_in_posts = 1;		# Set to 0 to hide the bar in members posts
$view_in_profile = 1;		# Set to 0 to hide the bar in members profile

#-------------------------------------------------------------------#

LoadLanguage("PopMeter");

my($thisuser, $viewnum, $start, $counter);

sub PopMeter {

	$thisuser = $_[0];
	$viewnum = $_[1];
	$start = $_[2];
	$counter = $_[3];

	my($popplus, $popminus);

	if($username ne $thisuser && !$iamguest) {
		$popplus = qq~<a href="$scripturl?action=popedit;membname=$thisuser;opin=1;num=$viewnum;start=$start;pnum=$counter"><img src="$imagesdir/smiley.gif" alt="" border="0" /></a>~;
		$popminus = qq~<a href="$scripturl?action=popedit;membname=$thisuser;opin=-1;num=$viewnum;start=$start;pnum=$counter"><img src="$imagesdir/sad.gif" alt="" border="0" /></a>~;
	}
	else {
		$popplus = qq~<img src="$imagesdir/smiley.gif" alt="" border="0" />~;
		$popminus = qq~<img src="$imagesdir/sad.gif" alt="" border="0" />~;
	}

	my ($memcount, $dummy) = &MembershipGet;

	$popbarwidth = $barwidth / 2;
	$popdiv = $popbarwidth;
	if($memcount > $popbarwidth) { $popdiv = $memcount }

	$popposnr = 0;

	if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); }

	if(${$uid.$thisuser}{'popularity'}) {
		$museropin = ${$uid.$thisuser}{'popularity'};
		$thisopin = abs($museropin);
		$tpoppos = int(($thisopin / $popdiv) * $popbarwidth);
		if($tpoppos > $popbarwidth) { $tpoppos = $popbarwidth; }
		if($museropin > 0) { $poppos = ($popbarwidth + $tpoppos) - 5; }
		else { $poppos = ($popbarwidth - $tpoppos) - 5; }
		$popposnr = $museropin;
	}
	else {
		$poppos = $popbarwidth - 5;
	}

	$popbarn = qq~<img src="$modimgurl/popmeter/Lightred.gif" width="$popbarwidth" height="10" alt="" border="0" />~;
	$popbarp = qq~<img src="$modimgurl/popmeter/Lightgreen.gif" width="$popbarwidth" height="10" alt="" border="0" />~;

	$barenh = qq~px~;
	$poppos .= qq~px~;

	my $popmain = qq~
		<div style="float: left; width: $barwidth$barenh; margin-bottom: 10px;">
		<div class="small" style="float: left; width: 100%;">
			$popltxt{'01'}: $popposnr
		</div>
		<div class="small" style="float: left; width: 100%; height: 8px;">
			<img src="$modimgurl/popmeter/pos_errow.gif" style="position: relative; left: $poppos; top: 5px; width: 11px; height: 8px;" width="11" height="8" alt="" border="0" />
		</div>
		<div class="small" style="float: left; width: 50%; height: 10px;">
			$popbarn
		</div>
		<div class="small" style="float: left; width: 50%; height: 10px;">
			$popbarp
		</div>
		<div class="small" style="float: left; width: 50%; padding-top: 2px;">
			$popminus
		</div>
		<div class="small" style="float: left; width: 50%; padding-top: 2px; text-align: right;">
			$popplus
		</div>
		</div>

	~;
	return $popmain;
}


sub PopEdit {
	my $thisuser = $INFO{'membname'};

	if($username eq $thisuser || $iamguest) { &fatal_error("$popltxt{'04'}"); }

	if($pop_timeout) {
		my($poptime, $popflood_user, $popflood_time, $popflood, $popflood_memb, @popfloodcontrol);
		$poptime = time;
		$poptimeoutsec = $pop_timeout * 60;
		if (-e "$vardir/popflood.txt") {
			fopen(FILE, "$vardir/popflood.txt");
			push(@popfloodcontrol,"$username|$poptime|$INFO{'membname'}\n");
			while( <FILE> ) {
				chomp($_);
				($popflood_user,$popflood_time,$popflood_memb) = split(/\|/,$_);
				if($username eq $popflood_user && $INFO{'membname'} eq $popflood_memb && $poptime - $popflood_time <= $poptimeoutsec) { $popflood = 1; }
				elsif( $poptime - $popflood_time < $poptimeoutsec ) { push( @popfloodcontrol, "$_\n" ); }
			}
			fclose(FILE);
		}
		if($popflood) {
			if(!$iamadmin) { &fatal_error("$popltxt{'02'} $pop_timeout $popltxt{'03'}"); } 
		}
		fopen(FILE, ">$vardir/popflood.txt", 1);
		print FILE @popfloodcontrol;
		fclose(FILE);
	}


	if (!${$uid.$thisuser}{'password'}) { &LoadUser($thisuser); }

	my $museropin = 0;
	if(${$uid.$thisuser}{'popularity'}) { $museropin = ${$uid.$thisuser}{'popularity'}; }

	if($INFO{'opin'} == 1) { $museropin++ }
	elsif($INFO{'opin'} == -1)  { $museropin-- }
	else { &fatal_error("$popltxt{'04'}"); }

	${$uid.$thisuser}{'popularity'} = $museropin;
	&UserAccount($thisuser, "update");

	if($INFO{'num'} == 0) {
		$yySetLocation = qq~$scripturl?action=viewprofile;username=$INFO{'membname'}~;
	}
	else {
		$yySetLocation = qq~$scripturl?num=$INFO{'num'}/$INFO{'start'}#$INFO{'pnum'}~;
	}
	&redirectexit;
}


1;